# $URL: http://pyisapie.svn.sourceforge.net/svnroot/pyisapie/Trunk/PyISAPIe/Python/Examples/Django/DjangoMap.py $
# $Rev: 187 $ $Date: 2010-04-16 18:11:49 -0700 (Fri, 16 Apr 2010) $
# (C)2008 Phillip Sitbon <phillip@sitbon.net>
#
"""Django application mapping.

This module, along with the per-interpreter os.environ hook in
the top-level Http package code, allows multiple Django sites to
run together in the same PyISAPIe/Python instance from separate
interpreters.

Beware that Django can use sqlite3, which AFAIK may not be compatible
with multiple interpreters. This is not guaranteed to work, but it
worked alright for me. (Disclaimer: I neither like nor use Django) 
"""
from django.core.handlers.wsgi import WSGIHandler as DjangoHandler
from Http.WSGI import RunWSGI
from Http import Env
from Http import Config
import os

def Install(Map):
  DjangoMaps = tuple((K, V) for K, V in Map if isinstance(V,str))
  OtherMaps = tuple((K, V) for K, V in Map if not isinstance(V,str))
  
  def InterpreterMap():
    PathInfo = Env.PATH_INFO
    
    for Key, Value in DjangoMaps:
      if PathInfo.startswith(Key):
        return Key
        
    return None
    
  # Not needed for non-main interpreters, but may
  # provide useful information somewhere.
  Config.InterpreterMap = InterpreterMap
    
  if __interp__ != "__main__":
    for Prefix, Settings in DjangoMaps:
      if __interp__ != Prefix:
        continue
      
      os.environ["DJANGO_SETTINGS_MODULE"] = Settings
      Handler = DjangoHandler()
      return lambda: RunWSGI(Handler, Base=Prefix)
        
    # each interpreter should have an assoc. prefix
    raise ValueError, "Unexpected interpreter '%s'" % __interp__
  
  def Request():
    PathInfo = Env.PATH_INFO

    for Prefix, Handler in OtherMaps:
      if PathInfo.startswith(Prefix):
        return Handler()

  return Request


