# $URL: http://pyisapie.svn.sourceforge.net/svnroot/pyisapie/Trunk/PyISAPIe/Python/Examples/Django/Isapi.py $
# $Rev: 198 $ $Date: 2010-05-03 11:55:56 -0700 (Mon, 03 May 2010) $
# (C)2008 Phillip Sitbon <phillip@sitbon.net>
#
"""Global ISAPI request handler.

Make sure to copy over DjangoMap.py with this file.

This version serves up multiple Django sites via separate interpreters.

A list of lists is used for the map because ordered dictionaries won't be
around until 2.7 :)

The performance hit for this setup appears to be minimal but noticeable.
It's almost definitely still better than FastCGI et al.
"""
from Http.WSGI import RunWSGI
from Http import Env
import DjangoMap

# The application map. Each "key" (first values of the lists) is
# a URL prefix you'd like to map to a specific Django settings
# module (the second value).
#
# If you don't have PyISAPIe configured as a wildcard script handler,
# you need to replace "lambda: True" with your own function that
# deals with URLs not handled here.
#
Map = [
  # This is an example of what paths might need to be handled by
  # other parts of IIS that still come here first. This value's
  # default of "/media" assumes that you've mapped a virtual
  # directory to Django's admin media folder and so expect the
  # files to be served by the static file handler.
  #
  ["/media" , lambda: True        ], # exclude and passthrough
  
  
  # These prefixes are how the WSGI module determines what SCRIPT_NAME
  # and PATH_INFO should consist of. They also determine the sub-
  # interpreter that the Django apps run in.
  # 
  ["/1"     , "mysite.settings"   ], # first Django app
  ["/2"     , "mysite2.settings"  ], # second
  
  # The default. If you have directory browsing enabled, you should
  # see a file listing at the root of your website. With this setup,
  # you can disable the "/media" passthrough, but I'm leaving it in
  # as an example.
  #
  ["/"      , lambda: True        ], # default: passthrough
]

Request = DjangoMap.Install(Map)
